#include <TinyGPS.h> 
#include <Wire.h>

int HMC6352Address = 0x42;
int slaveAddress;
byte headingData[2];
int i, headingValue;
int headingcompass;

char incoming[100];
byte in_index = 0;
byte decode_index = 0;

const int black = 46;
const int red = 48;
const int yellow = 50;
const int green = 52;

//GPS
float dist_calc=0;
float flat1;  // flat1 = our current latitude. flat is from the gps data. 
float flon1;  // flon1 = our current longitude. flon is from the fps data.
float x2lat;  //enter a latitude point here   this is going to be your waypoint
float x2lon;  // enter a longitude point here  this is going to be your waypoint
int heading;

int b1 = 0;
int b2 = 0;
int b3 = 0;
int b4 = 0;
int l = 0;
int waypoints = 0;
int way = 5;
float flat, flon;
long lat, lon;
unsigned long age, date, time, chars;
unsigned short sentences, failed;
float waylat[6];
float waylon[6];

//---------------------PD control
int output;
int error;
int last_error;
unsigned long start_time;
int direct = 0;

//motor controller
int motor1Input1 = 8;    // Motor1 inputs connected to pin 4 & 2
int motor1Input2 = 11;
int motor1Pwm= 13;         // Motor1 PWM pin
int motor2Input1= 7;      // Motor2 inputs connected to pin 7 & 5
int motor2Input2= 4;
int motor2Pwm= 2;           // Motor2 PWM pin
int enable1= 10;
int enable2= 5;
int disable1= 12;
int disable2= 3;
int fault1= 9;
int fault2= 6;
const int pwm1= 255; //for forward + reverse
int pwm2= 255; //for left + right

TinyGPS gps;

void gpsdump(TinyGPS &gps);
bool feedgps();
void printFloat(double f, int digits = 2);


///////////////////////////////////////////////////////////
void setup()
{
  Serial.begin(115200);
  Serial1.begin(4800);
  Serial2.begin(115200);
  
  slaveAddress = HMC6352Address >> 1; 
 
  Wire.begin();
  
  pinMode(motor1Input1, OUTPUT);      // sets all pins as outputs or inputs
  pinMode(motor1Input2, OUTPUT);
  pinMode(motor2Input1, OUTPUT);
  pinMode(motor2Input2, OUTPUT);
  pinMode(enable1, OUTPUT);
  pinMode(enable2, OUTPUT);
  pinMode(disable1, OUTPUT);
  pinMode(disable2, OUTPUT);
  pinMode(fault1, INPUT);
  pinMode(fault2, INPUT);
  
  pinMode (black, INPUT);
  pinMode (red, INPUT);
  pinMode (yellow, INPUT);
  pinMode (green, INPUT);
  
  delay(2000);
  Serial2.print(12,BYTE);
  Serial2.print(254,BYTE);
  Serial2.print(76,BYTE);
  Serial2.print(1,BYTE);
  Serial2.println(" GPS Rover 1.0. ");
  delay (1000);
  Serial2.println("     Start");
  delay(1000);
  
  lcdmenu();
}


//////////////////////////////////////////////////////////////////
void loop()
{
    /*wait();
  
    if (listen)
    {
      Serial.println("Acquired Data");
      Serial.println("-------------");
      Serial.print("waypoint lat ");
      printFloat(waylat[l], 7);
      Serial.print(" , ");
      Serial.print("waypoint lon ");
      printFloat(waylon[l], 7);
      Serial.println();
      */gpsdump(gps);
      /*Serial.print("Lat/Long(float): "); printFloat(flat, 7); 
      Serial.print(", "); printFloat(flon, 7);
      Serial.print(" Fix age: "); Serial.print(age); Serial.println("ms.");
      Serial.print(" failed checksum: "); Serial.println(failed); 
      */compass();
      distance();
      bearing();
      PIDVal();
      /*Serial.println("current heading:");
      Serial.println(headingcompass);

      Serial.println("required heading:");
      Serial.println(heading);   // print the heading.
      
      Serial.println("distance");
      Serial.println(dist_calc);    //print the distance in meters

      Serial.println(pwm2);
      */go();
      delay(200);  //slow loop down to update every fifth of a second
      /*Serial.println("-------------");
      Serial.println();
      */b4 = digitalRead(red);
      if (b4 == HIGH)
      {
        l++;
        Serial2.print(254,BYTE);
        Serial2.print(76,BYTE);
        Serial2.print(2,BYTE);
        Serial2.print("red next wp ");
        Serial2.println(l);
        delay(500);
      }
      if (l>waypoints)
      {
        finish();
      }
    //}
}


///////////////////////////////////////////////////////////////
/*void printFloat(double number, int digits)
{
// Handle negative numbers
  if (number < 0.0)
  {
     Serial.print('-');
     number = -number;
  }

// Round correctly so that print(1.999, 2) prints as "2.00"
  double rounding = 0.5;
  for (uint8_t i=0; i<digits; ++i)
    rounding /= 10.0;
  
  number += rounding;

// Extract the integer part of the number and print it
  unsigned long int_part = (unsigned long)number;
  double remainder = number - (double)int_part;
  Serial.print(int_part);

// Print the decimal point, but only if there are digits beyond
  if (digits > 0)
    Serial.print("."); 
// Extract digits from the remainder one at a time
  while (digits-- > 0)
  {
    remainder *= 10.0;
    int toPrint = int(remainder);
    Serial.print(toPrint);
    remainder -= toPrint; 
  } 
}*/


/////////////////////////////////////////////////////////////////////
//get info from gps
void gpsdump(TinyGPS &gps)
{
  gps.f_get_position(&flat, &flon, &age);  
  feedgps();
  gps.stats(&chars, &sentences, &failed);
  
  waylat[i] = flat;
  waylon[i] = flon;
}
 
  
bool feedgps()
{
  while (Serial1.available())
  {
    if (gps.encode(Serial1.read())){
      gpsdump(gps);
      return true;
     }
  }
  return false;
}


/////////////////////////////////////////////////////////////////
//this function will do all the calculations
void distance() 
{ 
 
  float dist_calc2=0;
  float diflat=0;
  float diflon=0; 
  flat1=flat;   // flat1 = our current latitude. flat is from the gps data. 
  flon1=flon;  // flon1 = our current longitude. flon is from the fps data.
  x2lat=  waylat[l];  //enter a latitude point here   this is going to be your waypoint
  x2lon=  waylon[l];  // enter a longitude point here  this is going to be your waypoint

//distance formula below. Calculates distance from current location to waypoint
  diflat=radians(x2lat-flat1);  //notice it must be done in radians
  flat1=radians(flat1);    //convert current latitude to radians
  x2lat=radians(x2lat);  //convert waypoint latitude to radians
  diflon=radians((x2lon)-(flon1));   //subtract and convert longitudes to radians
  dist_calc = (sin(diflat/2.0)*sin(diflat/2.0));
  dist_calc2= cos(flat1);
  dist_calc2*=cos(x2lat);
  dist_calc2*=sin(diflon/2.0);                                       
  dist_calc2*=sin(diflon/2.0);
  dist_calc +=dist_calc2;
  dist_calc=(2*atan2(sqrt(dist_calc),sqrt(1.0-dist_calc)));
  dist_calc*=6371000.0; //Converting to meters

  if(dist_calc <= 1.5 || dist_calc >= 250)
  {
    finish();
  }
}


//////////////////////////////////////////////////////////
//slow loop down to update every fifth of a second
/*void wait()
  { 
    long start = millis();
    do
    {
      delay(5);
    }while(millis() - start < 200);
  }*/


/////////////////////////////////////////////////////////////////
//when all saved waypoints have been reached wait for reset
void finish()
{

  if (l>=waypoints)
  {
    digitalWrite(disable1, HIGH);
    digitalWrite(disable2, HIGH);
  
    do
    {
      b3 = digitalRead(yellow);
      Serial2.print(254,BYTE);
      Serial2.print(76,BYTE);
      Serial2.print(1,BYTE);
      Serial2.println("     finish");
      Serial2.println("yellow reset");
    
      delay(50);
    
    }while (b3 == LOW);
    
    l=0;
    waypoints=0;
    lcdmenu();
    
  }
  
  else
  {
    l++;
    Serial2.print(254,BYTE);
    Serial2.print(76,BYTE);
    Serial2.print(2,BYTE);
    Serial2.print("red next wp ");
    Serial2.println(l);
  }
}


///////////////////////////////////////////////////////////////
//LCD menu to save waypoints
void lcdmenu()
{
  /*do
  {
  wait();
  
        if (wait)
          {*/
            gpsdump(gps);
            delay(10);
            //i++;
         // }
  //}while(i<1);
  
  Serial2.print(12,BYTE);
  Serial2.print(254,BYTE);
  Serial2.print(76,BYTE);
  Serial2.print(1,BYTE);
  Serial2.println("press black to");
  Serial2.println("save waypoint");
  
  delay(1000);
  //i=0;
  do
  {
    //check buttons
    b1 = digitalRead(green);
    b2 = digitalRead(black);
    
    //save waypoints
    if (i<way)
    {
    if (b2 == HIGH)
      {
        /*wait();
  
        if (wait)
          {*/
            delay(500);
            gpsdump(gps);
            Serial2.print(12,BYTE);
            Serial2.print(254,BYTE);
            Serial2.print(76,BYTE);
            Serial2.print(1,BYTE);
            Serial2.println("saving waypoint");
            i++;
            Serial2.println(i);
            waypoints++;
            delay(1000);
            Serial2.print(12,BYTE);
            Serial2.print(254,BYTE);
            Serial2.print(76,BYTE);
            Serial2.print(1,BYTE);
            Serial2.println("waypoint saved");
            delay(1000);
            Serial2.print(12,BYTE);
            Serial2.print(254,BYTE);
            Serial2.print(76,BYTE);
            Serial2.print(1,BYTE);
            Serial2.println("black waypoint");
            Serial2.println("green program");
          //}
      }
    }
    
    //if lon and lat arrays are full
    else 
    {
      Serial2.print(254,BYTE);
      Serial2.print(76,BYTE);
      Serial2.print(1,BYTE);
      Serial2.println("press green to");
      Serial2.println("start program");
      
      delay(50);
    }
  } while(b1 == LOW);
  l=0;
  Serial2.print(12,BYTE);
  Serial2.print(254,BYTE);
  Serial2.print(76,BYTE);
  Serial2.print(1,BYTE);
  Serial2.println("program starting"); 
  delay(1000);
  Serial2.print(12,BYTE);
  Serial2.print(254,BYTE);
  Serial2.print(76,BYTE);
  Serial2.print(1,BYTE);
  Serial2.println(" GPS Rover 1.0. "); 
  Serial2.print(254,BYTE);
  Serial2.print(76,BYTE);
  Serial2.print(2,BYTE);
  Serial2.print("red next wp ");
  Serial2.println(l); 
}


//////////////////////////////////////////////////////////
//calculate PID value
void PIDVal()
{
  error=(headingcompass-heading);
  //handle wrap-around  
  if (error < -180)
  { 
    error = error + 360;  
  }
  else if (error > 180)
  {
    error = error - 360;
  }
  if (error < 0)
  {
    direct = 0;
  }
  else 
  {
    direct = 1;
  }
  Serial.println(error);
  float HEADING_KP=1.75;   //gains. Randomly choosen right now. Not tuned
  float HEADING_KD=.5;
  float HEADING_KI=10000; 
  int derror = ((error - last_error) / 2); 
  int ierror = ((error + last_error) / 2);   
  float diff = (HEADING_KP * error) + (HEADING_KD * derror);
  int PD_output = diff;
  Serial.println(PD_output);
  PD_output = constrain(PD_output, -90, 90);
  Serial.println(PD_output);
  last_error = error;
  
  if (PD_output >= 0)
  { 
    Serial.println("greater");
    pwm2 = map(PD_output, 0, 105, 255, 0);
  }
  
  else if (PD_output < 0)
  { 
    Serial.println("less");
    pwm2 = map(PD_output, -105, 0, 0, 255);
  }
  
  else
  { 
    Serial.println("other");
    pwm2 = 255;
  }
}


/////////////////////////////////////////////////////////////////
//compass reading
void compass()
{
  Wire.beginTransmission(slaveAddress);        //the wire stuff is for the compass module
  Wire.send("A");
  Wire.endTransmission();
  delay(10);                  
  Wire.requestFrom(slaveAddress, 2);       
  i = 0;
  while(Wire.available() && i < 2)
  { 
    headingData[i] = Wire.receive();
    i++;
  }
  headingValue = headingData[0]*256 + headingData[1];
  int pracheading = headingValue / 10;      // this is the heading of the compass
  if(pracheading>0)
  {
    headingcompass=pracheading;
  }
}


///////////////////////////////////////////////////////////
//gps bearing
void bearing()
{
  flon1 = radians(flon1);  //also must be done in radians
  x2lon = radians(x2lon);  //radians duh.
  heading = atan2(sin(x2lon-flon1)*cos(x2lat),cos(flat1)*sin(x2lat)-sin(flat1)*cos(x2lat)*cos(x2lon-flon1)),2*3.1415926535;
  heading = heading*180/3.1415926535;  // convert from radians to degrees
  int head =heading; //make it a integer now
  if(head<0)
  {
    heading+=360;   //if the heading is negative then add 360 to make it positive
  }
}


///////////////////////////////////////////////////////////
//motor controller
void go()
{
  switch (direct)
  {
    case 0:
      Serial2.print(254,BYTE);
      Serial2.print(76,BYTE);
      Serial2.print(1,BYTE);
      Serial2.print("r ");
      Serial2.print(dist_calc);
      Serial2.print(" pwm ");
      Serial2.println(pwm2);
    
      digitalWrite(enable1, HIGH);
      digitalWrite(disable1, LOW);
      digitalWrite(motor1Input1, LOW);   // Motor1 on
      digitalWrite(motor1Input2, HIGH); 
      analogWrite(motor1Pwm,pwm1);  // Motor1 PWM Pulse
  
      digitalWrite(enable2, HIGH);
      digitalWrite(disable2, LOW);
      digitalWrite(motor2Input1, HIGH);   // Motor2 on
      digitalWrite(motor2Input2, LOW); 
      analogWrite(motor2Pwm,pwm2);  // Motor2 PWM Pulse
      break;
    
    case 1:
      Serial2.print(254,BYTE);
      Serial2.print(76,BYTE);
      Serial2.print(1,BYTE);
      Serial2.print("l ");
      Serial2.print(dist_calc);
      Serial2.print(" pwm ");
      Serial2.println(pwm2);
    
      digitalWrite(enable1, HIGH);
      digitalWrite(disable1, LOW);
      digitalWrite(motor1Input1, LOW);   // Motor1 on
      digitalWrite(motor1Input2, HIGH); 
      analogWrite(motor1Pwm,pwm2);  // Motor1 PWM Pulse
  
      digitalWrite(enable2, HIGH);
      digitalWrite(disable2, LOW);
      digitalWrite(motor2Input1, HIGH);   // Motor2 on
      digitalWrite(motor2Input2, LOW); 
      analogWrite(motor2Pwm,pwm1);  // Motor2 PWM Pulse
      break;
  }
}
